﻿
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Net;
using System.Net.Sockets;
using System.Threading;
using System.Management;

using MachineControl;

namespace Client
{
    class Program
    {
        static bool isConnected = false;
        static void Main(string[] args)
        {
            string shareFolderDirectory = @"c:\qm";
            string shareFolderName = "qm";
            string remoteMachine = "machineName";
            string remoteMachineUserName = @"yonghuming(inclue domain)";
            string remoteMachinePassWord = "password";

            string myMachineDomain = "yuming";
            string myMachineUserName = "yonghuming";
            string toolName = "Tool.exe";
            string cmdCreateFolder = string.Format(@"cmd /c md {0}", shareFolderDirectory);
            string cmdExecuteTool = string.Format(@"{0}\{1} {2}", shareFolderDirectory, toolName, "create");

            //step 1: create sub direcotry on remtoeMachine           
            ExecuteCommand.Execute(remoteMachine, remoteMachineUserName, remoteMachinePassWord, cmdCreateFolder);

            //step 2: create a share folder on remoteMachine
            WindowsShare.MethodStatus status = WindowsShare.CreateShareFolder(shareFolderDirectory, shareFolderName, WindowsShare.ShareType.DiskDrive, "ShareFolder", remoteMachine, remoteMachineUserName, remoteMachinePassWord);
            if (WindowsShare.MethodStatus.Success != status)
            {
                Console.WriteLine(string.Format("Can't create shareFolder, the status is'{0}'.", status.ToString()));
            }

            WindowsShare ws = WindowsShare.GetShareByName(remoteMachine, remoteMachineUserName, remoteMachinePassWord, shareFolderName);
            //step 3: get full control of share folder
            ws.SetPermission(myMachineDomain, myMachineUserName, WindowsShare.AccessMaskTypes.FullControl);

            //step 4: copy tool to share folder
            System.IO.File.Copy(Environment.CurrentDirectory + @"\" + toolName, @"\\" + remoteMachine + @"\" + shareFolderName + @"\" + toolName);

            //step 5: start tool with argument to do special operation on remote machine
            ExecuteCommand.Execute(remoteMachine, remoteMachineUserName, remoteMachinePassWord, cmdExecuteTool);
        }

    }
}

