﻿using System.Management;
using System.Security.Principal;
using System.Collections.Generic;
using System;

namespace MachineControl
{
    public class ExecuteCommand
    {
        public static void Execute(string remoteMachine, string username, string password, string cmd)
        {
            ConnectionOptions connOptions = new ConnectionOptions
            {
                Impersonation = ImpersonationLevel.Impersonate,
                EnablePrivileges = true,
                Username = username,
                Password = password
            };

            ManagementScope scope = new ManagementScope(@"\\" + remoteMachine + @"\root\cimv2", connOptions);
            scope.Connect();

            ObjectGetOptions options = new ObjectGetOptions();

            // Getting the process class and the process startup class
            ManagementPath processClassPath = new ManagementPath("Win32_Process");

            ManagementClass processClass = new ManagementClass(scope, processClassPath, options);

            // Settings the parameters for the Create method in the process class
            ManagementBaseObject inArgs = processClass.GetMethodParameters("Create");
            inArgs["CommandLine"] = cmd;

            // Invoking the method
            ManagementBaseObject returnValue = processClass.InvokeMethod("Create", inArgs, null);
            if ((uint)(returnValue.Properties["ReturnValue"].Value) != 0)
                throw new Exception("Folder might be already in share or unable to share the directory");
        }
    }
}
